/*! typed-dom v0.0.307 https://github.com/falsandtru/typed-dom | (c) 2016, falsandtru | (Apache-2.0 AND MPL-2.0) License */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["typed-dom"] = factory();
	else
		root["typed-dom"] = factory();
})(this, () => {
return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ 128:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {



__webpack_require__(921);

const global = void 0 || typeof globalThis !== 'undefined' && globalThis // @ts-ignore
|| typeof self !== 'undefined' && self || Function('return this')();
global.global = global;
module.exports = global;

/***/ }),

/***/ 921:
/***/ (() => {

 // @ts-ignore

var globalThis; // @ts-ignore

var global = (/* unused pure expression or super */ null && (globalThis));

/***/ }),

/***/ 325:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.unique = exports.rndAf = exports.rndAP = exports.rnd0_ = exports.rnd0Z = exports.rnd0v = exports.rnd0f = exports.rnd64 = exports.rnd62 = exports.rnd32 = exports.rnd16 = void 0;

const global_1 = __webpack_require__(128);

const radixes = Object.freeze([...Array(7)].map((_, i) => 1 << i));
const masks = Object.freeze(radixes.map(radix => radix - 1));
const dict0_ = Object.freeze([...[...Array(36)].map((_, i) => i.toString(36)), ...[...Array(36)].map((_, i) => i.toString(36).toUpperCase()).slice(-26), '-', '_']);
const dictAz = Object.freeze([...[...Array(36)].map((_, i) => i.toString(36).toUpperCase()).slice(-26), ...[...Array(36)].map((_, i) => i.toString(36)).slice(-26)]);
exports.rnd16 = cons(16);
exports.rnd32 = cons(32);
exports.rnd62 = cons(62);
exports.rnd64 = cons(64);
exports.rnd0f = conv(exports.rnd16, dict0_);
exports.rnd0v = conv(exports.rnd32, dict0_);
exports.rnd0Z = conv(exports.rnd62, dict0_);
exports.rnd0_ = conv(exports.rnd64, dict0_);
exports.rndAP = conv(exports.rnd16, dictAz);
exports.rndAf = conv(exports.rnd32, dictAz);

function unique(rnd, len = 1, mem) {
  const independence = !mem;
  mem ??= new global_1.Set();
  const trials = 3;
  let prefixes;
  let prefix = '';
  return function random() {
    for (let i = 0; i < trials; ++i) {
      const r = rnd(len);
      if (mem.has(r)) continue;

      try {
        mem.add(r);
      } catch (reason) {
        // ベンチマーク程度でもSetがパンクする場合がある。
        if (!independence) throw reason;
        prefixes ??= new global_1.Set();
        prefix ||= '?';

        for (let i = 0; i < trials; ++i) {
          prefix = rnd(prefix.length);
          if (prefixes.has(prefix)) continue;
          prefixes.add(prefix);
          mem.clear();
          return random();
        }

        prefixes = new global_1.Set();
        prefix += '?';
        return random();
      }

      return prefix + r;
    }

    ++len;
    independence && mem.clear();
    return random();
  };
}

exports.unique = unique;

function cons(size) {
  const len = radixes.findIndex(radix => radix >= size);
  return function rnd() {
    const r = random(len);
    return r < size ? r : rnd();
  };
}

function conv(rnd, dict) {
  return (len = 1) => {
    let acc = '';

    while (len--) {
      acc += dict[rnd()];
    }

    return acc;
  };
}

const buffer = new Uint16Array(512);
const digit = 16;
let index = buffer.length;
let offset = digit;

function random(len) {
  if (index === buffer.length) {
    global_1.crypto.getRandomValues(buffer);
    index = 0;
  }

  if (offset === len) {
    offset = digit;
    return buffer[index++] & masks[len];
  } else if (offset > len) {
    offset -= len;
    return buffer[index] >> offset & masks[len];
  } else {
    offset = digit;
    ++index;
    return random(len);
  }
}

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
(() => {
var exports = __webpack_exports__;


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.identity = void 0;

const global_1 = __webpack_require__(128);

const random_1 = __webpack_require__(325);

const rnd = (0, random_1.unique)(random_1.rnd0Z);
const mask = 32 - 1;
const dict = Object.freeze([...Array(36)].map((_, i) => i.toString(36)));
let r = '';
let c = mask;

exports.identity = global_1.global[Symbol.for('typed-dom::identity')] ??= () => `${c === mask ? r = rnd() : r}${dict[c = ++c & mask]}`;
})();

/******/ 	return __webpack_exports__;
/******/ })()
;
});